﻿using System;
using System.Windows.Forms;
using Telerik.WinControls.Layouts;
using Telerik.WinControls.UI;

namespace GridViewCustomViewExample
{
    public partial class Form1 : RadForm
    {
        GridViewDetailElement detailView;

        public Form1()
        {
            InitializeComponent();

            InitializeGridControl();
        }

        private void InitializeGridControl()
        {
            this.rgDetails.Columns.Add("Id");
            this.rgDetails.Columns.Add("State");
            this.rgDetails.Columns.Add("StartName");
            this.rgDetails.Columns.Add(new GridViewCheckBoxColumn() { Name = "TrackService" });
            this.rgDetails.Columns.Add("ServiceType");

            for (int i = 0; i < 20; i++)
            {
                string status;
                int left = i % 3;

                if (left == 0)
                {
                    status = "Running";
                }
                else if (left == 1)
                {
                    status = "Paused";
                }
                else if (left == 2)
                {
                    status = "Stoped";
                }
                else
                {
                    status = "Invalid";
                }

                this.rgDetails.Rows.Add(i, status, "Name " + i, i % 2 == 0, "Type " + i);
            }


            this.rgDetails.TableElement.SetValue(DockLayoutPanel.DockProperty, Telerik.WinControls.Layouts.Dock.Top);
            this.rgDetails.TableElement.Margin = new Padding(10, 0, 10, 10);
            this.detailView = new GridViewDetailElement();
            this.rgDetails.GridViewElement.Panel.Children.Insert(1, this.detailView);
            this.detailView.SetValue(DockLayoutPanel.DockProperty, Telerik.WinControls.Layouts.Dock.Bottom);
            this.detailView.Margin = new Padding(10, 0, 10, 2);
        }
    }
}