﻿using System;
using System.Drawing;
using System.Linq;
using Telerik.WinControls;
using Telerik.WinControls.UI;

namespace GridViewCustomViewExample
{
    public class GridViewDetailElement : GridVisualElement, IGridView
    {
        private RadGridViewElement gridElement;
        private GridViewInfo viewInfo;
        public DetailElement detailPanel;

        #region Fields

        private RadHostItem hostDetailView;

        #endregion

        #region Initialization

        protected override void InitializeFields()
        {
            base.InitializeFields();

            this.Padding = new System.Windows.Forms.Padding(10);
            this.StretchHorizontally = true;
            this.MinSize = new Size(0, 250);
            this.MaxSize = new Size(0, 250);
            this.DrawFill = true;
            this.Class = "RowFill";
            this.detailPanel = new DetailElement();
        }

        protected override void CreateChildElements()
        {
            base.CreateChildElements();
            hostDetailView = new RadHostItem(detailPanel);
            this.Children.Add(hostDetailView);
        }

        public void Initialize(RadGridViewElement gridElement, GridViewInfo viewInfo)
        {
            this.gridElement = gridElement;
            this.viewInfo = viewInfo;
            this.gridElement.GridControl.CurrentRowChanged += new CurrentRowChangedEventHandler(GridControl_CurrentRowChanged);
        }

        public void Detach()
        {
            this.gridElement.GridControl.CurrentRowChanged -= new CurrentRowChangedEventHandler(GridControl_CurrentRowChanged);
            this.gridElement = null;
            this.viewInfo = null;
        }

        public void UpdateView()
        {
            GridViewDataRowInfo dataRow = this.GridViewElement.GridControl.CurrentRow as GridViewDataRowInfo;

            if (dataRow != null)
            {
                detailPanel.UpdateUCView(dataRow);
            }
        }

        public RadGridViewElement GridViewElement
        {
            get { return this.gridElement; }
        }

        public GridViewInfo ViewInfo
        {
            get { return this.viewInfo; }
        }

        #endregion

        #region Event Handlers

        private void GridControl_CurrentRowChanged(object sender, CurrentRowChangedEventArgs e)
        {
            this.UpdateView();
        }

        #endregion
    }
}
